/*
 * Copyright 2013-2016 ISP RAS (http://www.ispras.ru), UniTESK Lab (http://www.unitesk.com)
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 * 
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */

package ru.ispras.castle.ast.basis;

/**
 * {@link ErrorHandler} is a base interface of an error handler.
 * 
 * @author <a href="mailto:kamkin@ispras.ru">Alexander Kamkin</a>
 */
public interface ErrorHandler<Tag extends Enum<Tag>> {
  /**
   * Handles an error.
   * 
   * @param newNode the current node.
   * @param oldNode the old node (for handling redefinition errors). 
   */
  void handle(SyntaxNode<Tag> newNode, SyntaxNode<Tag> oldNode);
}
